function [A,M,xnew] = GenerateFEM(x,a,b)
% doc to be written
dx = diff(x(:));
n = length(x)-1;
xnew = [x(:)';x(:)' + [dx',0]/2]; xnew = xnew(1:end-1); xnew = xnew(:);
A = sparse(2*n+1,2*n+1); M = A;
%% interpolation matrix for the function values
s06 = sqrt(0.6);
G0 = [3/10+s06/2, 4/10, 3/10-s06/2;
               0,    1,          0;
      3/10-s06/2,  4/10, 3/10+s06/2];
%% interpolation matrix for the derivative  values
G1 = [-1-2*s06,  +4*s06, +1-2*s06;
            -1,       0,        1;
      -1+2*s06, -4*s06, +1+2*s06];
W = diag([5 8 5])/18;
for ind = 1:n
  x_elem = x(ind)+dx(ind)/2*(1+[-s06 0 s06]);
  M_elem = dx(ind)*G0'*W*diag(b(x_elem))*G0;
  A_elem = (G1'*W*diag(a(x_elem))*G1)/dx(ind);
  ra = 2*ind-1:2*ind+1;
  M(ra,ra) = M(ra,ra) + M_elem;  
  A(ra,ra) = A(ra,ra) + A_elem;
end%for
end%function
