R = 50; % space interval [0,R]
T =  6; % time interval [0,T]
x = linspace(0,R,200); Nt = 200;

LogF = @(u) max(0,u.*(1-u));  al = 10; % scaling factor
u0   = @(x,R)0.001*exp(-x.^2/4);
a = @(x) x.^2;  b = @(x) x.^2;
[A,M,r] = GenerateFEM(x,a,b);
dt = T/Nt; u = u0(r,R);  t = 0;

for ii = 1:Nt
  u = (M+dt/2*A)\((M-dt/2*A)*u + dt*M*al*LogF(u));% Crank-Nicolson
  t = t + dt;
  figure(1)
  plot(r,u)
  xlabel('Radius r'); ylabel('density u')
  axis([0 R -0.2 1.1]); text(0.7*R,0.7,sprintf('t = %5.3f',t))
  drawnow(); 
  %pause(0.01)
end%for
