% short
R = 35/3; % space interval [0,R]
T = 5/3; % time interval [0,T]
Nx = 100; x = linspace(0,R,Nx); Nt = 100;
% long
R = 100; % space interval [0,R]
T = 15; % time interval [0,T]
Nx = 400; x = linspace(0,R,Nx); Nt = 400;

u_all = zeros(2*Nx-1,Nt+1);
LogF = @(u) max(0,u.*(1-u)); al = 10; % scaling factor
u0 = @(x,R)0.001*exp(-x.^2/4);
a  = @(x) x.^2;  b = @(x) x.^2;
[A,M,r] = GenerateFEM(x,a,b);

dt = T/Nt;
u = u0(r,R);
u_all(:,1) = u;
t = 0;
for ii = 1:Nt
  u = (M+dt/2*A)\((M-dt/2*A)*u + dt*M*al*LogF(u));% Crank-Nicolson,
  t = t + dt;
  u_all(:,ii+1) = u;
end%for

figure(2)
mesh(0:dt:T,r,u_all)
ylabel('radius r'); xlabel('time t'); zlabel('concentration u')
axis([0,T,0,R,0,1])

figure(3)
contour(0:dt:T,r,u_all,[0.1 0.5,0.9])
caxis([0 1])
ylabel('radius r'); xlabel('time t')
