N = 10;              % number of elements, then 2*N+1 nodes
x = linspace(0,1,N+1);
a = @(x) 1*ones(size(x));
b = @(x) 1*ones(size(x));

[A,M,r] = GenerateFEM(x,a,b);
A = A(2:end-1,2:end-1); M = M(2:end-1,:); % Dirichlet BC on both ends
f = ones(size(r(:)));
u_exact = r(:).*(1-r(:))/2;
u = A\(M*f);

figure(1)
plot(r,[0;u;0],r,u_exact)
xlabel('r'); ylabel('u');title('solution, exact and approximate') 
  
figure(2)
plot(r,[0;u;0]-u_exact)
xlabel('r'); ylabel('u');title('difference of solutions, exact and approximate')
