N = 1*10;                   % number of elements
x = linspace(0,pi/2,N+1);
a = @(x) 1*ones(size(x));
b = @(x) 1*ones(size(x));

[A,M,r] = GenerateFEM(x,a,b);

A = A(1:end-1,1:end-1); % Neumann on the left and  Dirichlet BC on the right 
M = M(1:end-1,:);
f = cos(3*r(:));
u_exact = 1/9*cos(3*r(:));
u = A\(M*f);
figure(1)
plot(r,[u;0],r,u_exact)
xlabel('r'); ylabel('u');   xlim([0,pi/2])
title('solution, exact and approximate') 
figure(2)
plot(r,[u;0]-u_exact)
xlabel('r'); ylabel('u'); title('difference of exact and approximate solution')
