N = 20; R = 3;
x = linspace(0,R,N+1);
a = @(x) x.^2;
b = @(x) x.^2;

[A,M,r] = GenerateFEM(x,a,b);
A = A(1:end-1,1:end-1); % Dirichlet BC at the right end point
M = M(1:end-1,:);
r = r(:);  f = (6-4*r.^2).*exp(-r.^2);
u_exact = exp(-r.^2)-exp(-R^2);
u = A\(M*f);

figure(1)
plot(r,[u;0],r,u_exact)
xlabel('r'); ylabel('u'); title('solution, exact and approximate') 

figure(2)
plot(r,[u;0]-u_exact)
xlabel('r'); ylabel('u'); title('difference of exact and approximate solution')
