
EA = 1.0;  L = 3; uM = 0.2;   N = 20;
fRHS = @(x) sin(0.5*x);

h = L/(N+1); % stepsize 
x = (h:h:L-h)';
f = fRHS(x);
g = h^2/EA*f;  g(N) = g(N)+uM;

%% build the tridiagonal, symmetric matrix
di = 2*ones(N,1);      % diagonal
up = -ones(N-1,1);     % upper diagonal

u = trisolve(di,up,g);
figure(1);

plot([0;x;L],[0;u;uM])
xlabel('distance')
ylabel('displacement')
grid on

du = diff([0;u;uM])/h;
figure(2);
plot([0;x]+h/2,EA*du)
xlabel('distance')
ylabel('force')
grid on

