%%%%% script file to solve the heat equation on a unit square
n = 100;
%n = 7;
f = @(x,y) x.^2;  % describe the heating contribution

%%%%%%%%%%%%%%%%%%%%%%%%%%   no modifications necessary beyond this line
h = 1/(n+1);
Dxx = spdiags(ones(n,1)*[-1 2 -1],[-1 0 1],n,n)/h^2;
A = kron(Dxx,eye(n))+kron(eye(n),Dxx);


x = h:h:1-h; y = x;
[xx,yy] = meshgrid(x,y);     % generate the mesh for the graphics
fvec = f(xx(:),yy(:));       % compute the function
t0 = cputime();              % start the stop watch
u = A\fvec;                  % solve the system of equations
solutionTime = cputime()-t0  % display the solution time 
figure(1)
mesh(xx,yy,reshape(fvec,n,n))   % generate the graphics
xlabel('x'); ylabel('y');

%%% add on the zero boundary values for a nicer graphics
x = 0:h:1; y = x;
[xx,yy] = meshgrid(x,y);  uu = zeros(size(xx));
uu(2:n+1,2:n+1) = reshape(u,n,n);
figure(2)
surf(xx,yy,uu)
xlabel('x'); ylabel('y');
