#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include "timer.c"
#include "choldc.c"


#define NN 500
float **a,*p;

void nrinit(int n) ;
float *vector(int nl, int nh);
float **matrix(int nrl,int nrh,int ncl,int nch);
float runtime ;
double dd;

int
main(argc,argv) int argc; char **argv; {
int i,n;

  if(argc < 2) exit(0);
  n = atoi(argv[1]);
  nrinit(n);
  runtime = timer(0); 
  for(i=1;i<=10;i++){
        choldc(a,n,p);} 
/*       choldc(a,n,p);*/
  runtime = timer(1);
  fprintf(stderr,"Elapsed time = %f\n",runtime); 
  fprintf(stderr,"Flops/sec  =  %f M\n",1.0e-6*n*n*n/6.0/runtime*10); 
/*  fprintf(stderr,"Flops/sec  =  %f M\n",1.0e-6*n*n*n/6.0/runtime); */
  return(0);
}

void
nrinit(int n) {
int i,j ;
 a=matrix(1,n,1,n);
 p=vector(1,n);
for (i=1;i<=n;i++){
   for (j=i;j<=n;j++) a[i][j] = 1.0/n ;
   a[i][i] = 2.0 ;
   };
}

void
nrerror(char *text){
 fprintf(stderr,"Numerical recipes runtime error ...\n%s\nAborted\n",text);
 exit(1);
}

/* allocate float matrix in range [nrl..nrh][ncl...nch] */
float **matrix(int nrl,int nrh,int ncl,int nch){
float **m; int i;

/* allocate array of pointers to rows */
  m=(float **)malloc((unsigned int)(nrh-nrl+1)*sizeof(float *));
  if(!m) nrerror("allocation failure 1 in matrix()");
  m -= nrl;

/* allocate rows and set pointers to them */
  for(i=nrl;i<=nrh;++i) {
    m[i]=(float *)malloc((unsigned int)(nch-ncl+1)*sizeof(float));
    if(!m[i]) nrerror("allocation failure 2 in matrix()");
    m[i] -= ncl;
  }
/* return base address of array of pointers to rows */
  return (m);
}

float *vector(int nl, int nh)
/* allocate a float vector with subscript range v[nl..nh] */
{
#define NR_END 1
	float *v;
	v=(float *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(float)));
	if (!v) nrerror("allocation failure in vector()");
	return v-nl+NR_END;
}


