%% script file
x = 0:0.1:3;
f = @(x) x.*x - 1 - cos(x);
y = f(x);
figure(1);
plot(x,y)
grid on
xlabel('x'); ylabel('f(x)= x^2-1-cos(x)');

[c,info,msg] = fsolve('f',1.0)  % solve the equation

N = 201;     % increase to improve accuracy
%N = 2001;     % increase to improve accuracy
h = 2/(N+1); % stepsize 

x = (-1:h:1)';

% c = 1.176501940;
uexact = log(c^2./(1+cos(c*x)));


%%%% use Newton's method %%%%%%%%
%% build the triangular matrix
di = 2*ones(N,1)/h^2 ;  % main diagonal
up = -ones(N-1,1)/h^2;  % upper diagonal

Niterations = 5;
errorNewton = zeros(Niterations,1);
errorSubst  = errorNewton;

u = zeros(N,1);
for k = 1:Niterations
  g =  diff(diff([0;u;0]))/h^2-exp(u);
  u = u + trisolve(di+exp(u),up,g);
  errorNewton(k) = max(abs(uexact-[0;u;0]));
end%for
errorNewton

figure(2);
plot(x,[0;u;0],x,uexact)
xlabel('x'); ylabel('approximate and exact solution');
grid on
%%%%%%% use the method of successive substitutions

u = zeros(N,1);
for k = 1:Niterations
  g = -exp(u);
  u = trisolve(di,up,g);
  errorSubst(k) = max(abs(uexact-[0;u;0]));
end%for

errorSubst
figure(3);
plot(1:Niterations,log(errorNewton),1:Niterations,log(errorSubst))
xlabel('iterations'); ylabel('log of error'); grid on
